

#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include "lcd.h"
#include <stdio.h>
#include <math.h>


void reset_menu(void);

short int initial;
long int num;
long int maxtemp, mintemp;
extern long int hr, min;
char day[4], mon[4], tue[4], wed[4], thu[4], fri[4], sat[4], sun[4];

char output_string[10];
char style[10];


//Declarations for Checkbuttons////
extern int input;
extern void CheckButtons(void);
//extern unsigned char Buttons;
////////////////////////////////////

//Declarations from Main.c///
extern unsigned char dayDisplay[4];
extern int military;
/////////////////////////////////////

///Declarations from RTCtimer.c////
extern long int dayw;
///////////////////////////////


void reset_menu(void)
{

//hr=12;
//min=0;
input=0;
//dayw=2;

maxtemp=99;
mintemp=31;

 lcd_clrscr();
rstmenulp:
		
		lcd_puts("Up-Continue\n");
	    lcd_puts("Down - Exit\n");  
		
		  CheckButtons();								//wait for input

	if(input == 2 || input == 9)
	{
				return;
	}

	else if(input == 1)
	{
		goto rstmenulp1;
	}

	else
	{
		goto rstmenulp;
	}

rstmenulp1:
	 lcd_clrscr();
rstmenulp1b:		
		lcd_puts("temp-up time-dwn\n");			// print to screen			("temp-up time-dwn")
		lcd_puts("RST-fwd exit-bck\n");			//	[] indicates blinking	("RST-fwd exit-fwd")

		  CheckButtons();								//wait for input

	if(input == 1)
	{
		goto rstmenulp2;
	}

	else if(input == 2)
	{
		goto rstmenulp4;
	}

	else if(input == 3)
	{
		goto rstmenulp8;
	}

	else if(input == 4 || input == 5 || input == 9)
	{
				return;
	}

	else 
	{
		goto rstmenulp1b;
	}
	
rstmenulp2:

	lcd_clrscr();

rstmenulp2b:		
	
	lcd_puts("Max Temp:\n");						// print to screen			("Max Temp:")
	sprintf(output_string, "%3ld", maxtemp); 		// %2ld is 2 spaces to display a long int with no leading zeros
	lcd_puts(output_string);
	lcd_puts("\n");

rstmenulp2a:

	CheckButtons();								//wait for input


	if(input != 3)						// check to make sure the input is the fwd button
	{
		if(input == 1)						// check to see if the input is the up button
		{
         if(maxtemp==1) 
		 {
           maxtemp = 50;
		   lcd_clrscr();
         }
         
   			maxtemp ++;						// increment maxtemp

   	  		if(maxtemp > 100)				// make sure maxtemp does not go into three digit
	    	{
  				maxtemp = 150;
				lcd_clrscr();
				lcd_puts("Enter Max Temp:\n");
				lcd_puts(" MAX TEMP OFF\n");
		
				goto rstmenulp2a;

			}

		  goto rstmenulp2b;
         
		}

		else if(input == 2)						// check to see if the input is the up button
		{
         if(maxtemp==150) {
           maxtemp = 100;
		   lcd_clrscr();
           }
         
   			maxtemp --;						//decrement maxtemp

   			if(maxtemp <= 49)				// make sure maxtemp does not drop below 50
   			{
   				maxtemp = 1;
				lcd_clrscr();
				lcd_puts("Enter Max Temp:\n");
				lcd_puts("MAX TEMP OFF\n");
             
               goto rstmenulp2a;
   			}

	   		goto rstmenulp2b;           
		}

		else if(input == 4)					// if input is back button go back to previous loop
		{
			goto rstmenulp1;
		}

		else if(input == 5 || input == 9)
		{
         if(maxtemp==1)
            maxtemp=150;
      
			return;
		}
		
		else 
		{	
			if(maxtemp >100 || maxtemp < 50)
			{
				goto rstmenulp2a;
			}
			else
			{
				goto rstmenulp2b;
			}
		}
	}

     if(maxtemp==1)
       maxtemp=150;


rstmenulp3:

	lcd_clrscr();

rstmenulp3b:		

		
		lcd_puts("Min Temp:\n");
		sprintf(output_string, "%3ld", mintemp); 		// %2ld is 2 spaces to display a long int with no leading zeros
		lcd_puts(output_string);
		lcd_puts("\n");
	    
rstmenulp3a:

		  CheckButtons();								//wait for input
		  
//	if(input != 4)						// check to make sure the input is the fwd button
//	{
		if(input == 1)						// check to see if the input is the up button
		{
         if(mintemp == 1)
         {
			lcd_clrscr();
            mintemp = 31;
         }
         
   			mintemp ++;						// increment mintemp

     		if(mintemp >= 65)				// make sure min temp does not go above maxtemp - 5
   			{
   				mintemp = 150;
				lcd_clrscr();
				lcd_puts("Enter Min Temp:\n"); 		// %2ld is 2 spaces to display a long int with no leading zeros
				lcd_puts("MIN TEMP OFF\n");
				goto rstmenulp3a;
   			}

   			goto rstmenulp3b;
		}
      
		else if(input == 2)						// check to see if the input is the up button
		{
         if(mintemp == 150)
         {	
			lcd_clrscr();
            mintemp = 66;
         }
         
          	mintemp--;						//decrement maxtemp
   
	     if(mintemp <= 31)				// make sure mintemp does not drop below 33
		 {
			mintemp = 1;
			lcd_clrscr();
			lcd_puts("Enter Min Temp\n"); 		// %2ld is 2 spaces to display a long int with no leading zeros
            lcd_puts("MIN TEMP OFF\n");
			goto rstmenulp3a;
   		 }

   		goto rstmenulp3b;
   		
		}

		else if(input == 4)					// if input is back button go back to previous loop
		{
			goto rstmenulp2;
		}
      
		else if(input == 3)
		{
			goto rstmenulp1;
		}

		else if(input == 5 || input == 9)
		{
      
			if(mintemp==150) 
			{
				lcd_clrscr();
				 mintemp=1;
			}
				
			return;
		}
		
		else
		{
			if(mintemp > 100 || mintemp < 31)
			{
				goto rstmenulp3a;
			}
			else
			{
				goto rstmenulp3b;
			}
		}
//	}
      
rstmenulp4:
	 lcd_clrscr();

rstmenulp4d:

	if(military==1)
	{
		strcpy(style, "24 hour");
	}
	else if(military == 0)
	{
		strcpy(style, "12 hour");
	}
	
	lcd_puts("Clock style:\n");
	lcd_puts(style);
	lcd_puts("\n");
	
	CheckButtons();
	
	if(input == 1 || input == 2)
	{	
		if(military == 0)
		{
			military = 1;
		}
		else if(military ==1)
		{
			military = 0;
		}
		
		goto rstmenulp4d;
	}
	
	else if(input == 3)
	{
		goto rstmenulp4bb;
	}
	
	else if(input == 4)
	{
		goto rstmenulp1;
	}

	//else
	//{
		goto rstmenulp4d;
	//}

rstmenulp4bb:

	lcd_clrscr();
	
rstmenulp4b:		

		lcd_puts("Enter Time:\n");
		sprintf(output_string, "%2ld", hr); 		// %2ld is 2 spaces to display a long int with no leading zeros
		lcd_puts(output_string);
		lcd_puts(":");
		sprintf(output_string, "%02ld", min); 		// %2ld is 2 spaces to display a long int with no leading zeros
		lcd_puts(output_string);
		lcd_puts("\n");
		
		CheckButtons();						//wait for input

      
   //delay_ms(100);

	if(input != 3)						// check to make sure the input is the fwd button
	{
		if(input == 1)						// check to see if the input is the up button
		{
		

//			if(hr <= 23) //check to make sure hr does not go over 24
//			{
				++hr;
//			}

			if(hr > 23)
			{
				hr=0;
			}

			goto rstmenulp4b;
		}

		else if(input == 2) // check to see if the input is the down button
		{

//		   if(hr >= 0) //check to make sure hour does not go under 00
//			{
				--hr;
//			}	

			if(hr < 0)
			{
				hr = 23;
			}
		
			goto rstmenulp4b;
		}

		else if(input == 4)
		{
			goto rstmenulp4d;
		}

		else if(input == 5 || input == 9)
		{
			return;
		}
		
		else 
		{
			goto rstmenulp4b;
		}
	}

rstmenulp5:
	 lcd_clrscr();
rstmenulp5b:		

		lcd_puts("Enter Time:\n");
		sprintf(output_string, "%2ld", hr); 		// %2ld is 2 spaces to display a long int with no leading zeros
		lcd_puts(output_string);
		lcd_puts(":");
		sprintf(output_string, "%02ld", min); 		// %2ld is 2 spaces to display a long int with no leading zeros
		lcd_puts(output_string);
		lcd_puts("\n");
		
		CheckButtons();						//wait for input

     
   //dt delay_ms(100);

	if(input != 3)						// check to make sure the input is the fwd button
	{
		if(input == 1)						// check to see if the input is the up button
		{
		
		
		if(min < 59) //check to make sure min does not go over 59
			{
				++min;
			}
		
			else if(min >= 59)
			{
				min=0;
			}
              
			goto rstmenulp5b;
		}

		else if(input == 2)   // check to see if the input is the down button
		{
			if(min > 00) //check to make sure min does not go over 59
			{
				--min;
			}
      
			else if(min <= 00)  //APG changed tenmin > 1 to tenmin > 0 to help decrease.
			{
				min=59;
			}

			goto rstmenulp5b;
		}

		else if(input == 4)					// if input is back button go back to previous loop
		{
			goto rstmenulp4;
		}

		else if(input == 5 || input == 9)
		{
			return;
		}
		
		else
		{
			goto rstmenulp5b;
		}
	}

rstmenulp7:
	 lcd_clrscr();
rstmenulp7b:		

		lcd_puts("Enter Day:\n");
		//sprintf(output_string, "%2ld", dayDisplay); 		// %2ld is 2 spaces to display a long int with no leading zeros
		lcd_puts(dayDisplay);
		lcd_puts("\n");	

	CheckButtons();


   //dt delay_ms(100);

//	if(input != 4)						// check to make sure the input is the fwd button
//	{
		if(input == 1)						// check to see if the input is the up button
		{
			dayw++;
			if (dayw ==8 )
			{
				dayw=1;
			}
			
			if (dayw == 1)
			{
				strcpy(dayDisplay, "SUN");
			}
			else if(dayw == 2)
			{
				strcpy(dayDisplay, "MON");
			}
			else if(dayw == 3)	
			{
				strcpy(dayDisplay, "TUE");
			}
			else if(dayw == 4)
			{
				strcpy(dayDisplay, "WED");
			}
			else if(dayw == 5)
			{
				strcpy(dayDisplay, "THU");
			}
				else if(dayw == 6)
			{
				strcpy(dayDisplay, "FRI");
			}
			else if(dayw == 7)
			{
				strcpy(dayDisplay, "SAT");
			}

			goto rstmenulp7b;
		}

		else if(input == 2)
		{
			dayw--;
			if(dayw==0)
			{
				dayw = 7;
			}
			
				if (dayw == 1)
				{
					strcpy(dayDisplay, "SUN");
				}
				else if(dayw == 2)
				{
					strcpy(dayDisplay, "MON");
				}
				else if(dayw == 3)
				{
					strcpy(dayDisplay, "TUE");
				}
				else if(dayw == 4)
				{
					strcpy(dayDisplay, "WED");
				}
				else if(dayw == 5)
				{
					strcpy(dayDisplay, "THU");
				}
				else if(dayw == 6)
				{
					strcpy(dayDisplay, "FRI");
				}
				else if(dayw == 7)
				{
					strcpy(dayDisplay, "SAT");
				}
			goto rstmenulp7b;
		}

		else if(input == 4)					// if input is back button go back to previous loop
		{
			goto rstmenulp5;
		}
      else if(input == 3)
      {
         goto rstmenulp1;
      }

		else if(input == 5 || input == 9)
		{
			return;
		}
		
		else
		{
			goto rstmenulp7b;
		}
		
//	}

rstmenulp8:
	 lcd_clrscr();
rstmenulp8b:		


	lcd_puts("Up - Reset\n");
	lcd_puts("Down - Exit\n");  

	CheckButtons();

	if(input == 1)
	{
		initial = 0;
	}
	else if(input == 2 ||  input == 9)
	{
		return;
	}
	else
	{
		goto rstmenulp8b;
	}
	
	return;
}



