#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include "lcd.h"
#include <stdio.h>
#include "switches.h"
//#include <math.h>

extern int heat, cool, off;
extern int pgmnum;
extern int input_switch;

extern unsigned char status[10];

extern void CheckSwitches(void);

void set_switches(void)
{
//	pgmnum = 2;
	
// fan switch check (0 = auto, 1 = on)
	
//	if(/* fan auto */)
/*	{
		fan = 0;
	}
*/	
//	else if(/* fan on input */)
/*	{
		fan =  1;
	}
*/

// system mode switch checks to see if heat is on, if not then checks cool, if neither then off

	CheckSwitches();
	
	if (input_switch == 100)
	{
		//This is because it wont work without it for some reason.
	}

	else if (input_switch == 8) 
	{
		heat = 0;
		cool = 1;
		off = 0;
		
		strcpy(status, "COOL");
		
		pgmnum = 2;
		
	}
	
	
	else if (input_switch == 7)
	{
		heat = 1;
		cool = 0;
		off = 0;
		
		strcpy(status, "HEAT");
		
		pgmnum = 2;
	}
	
	// pgmnum number switch check (default = pgmnum 2, 1 = pgmnum 1, 3 = pgmnum 3
	
	else if(input_switch == 6)
	{
		strcpy(status, "OFF ");
	
		pgmnum = 1;
	}
	
	else if(input_switch == 5)
	{
		strcpy(status, "OFF ");
	
		pgmnum = 3;
	}
	
	///Combinations of Switches
	else if (input_switch == 87) //Switch8 and Switch7
	{
		heat = 0;
		cool = 0;
		off = 1;
		
		strcpy(status, "OFF ");
	
	}
	
	else if (input_switch == 86) //Switch8 and Switch6
	{
		heat = 0;
		cool = 1;
		off = 0;
		
		strcpy(status, "COOL");
		
		pgmnum = 1;
	}
	
	else if (input_switch == 85) //Switch8 and Switch5
	{
		heat = 0;
		cool = 1;
		off = 0;
		
		strcpy(status, "COOL");
		
		pgmnum = 3;
	}
	
	else if (input_switch == 76) //Switch7 and Switch6
	{
		heat = 1;
		cool = 0;
		off = 0;
		
		strcpy(status, "HEAT");
		
		pgmnum = 1;
	}
	
	else if (input_switch == 75) //Switch7 and Switch5
	{
		heat = 1;
		cool = 0;
		off = 0;
		
		strcpy(status, "HEAT");
		
		pgmnum = 3;
	}
	
	else if (input_switch == 65) //Switch6 and Switch5
	{	
		pgmnum = 2;
	}
	
	else
	{
		strcpy(status, "OFF ");
		
		pgmnum = 2;
	}
	
	///Defaults/////
	/*
	
	if (input_switch != 8 && input_switch != 7)// && input_switch != 86 && input_switch != 85)
	{
		heat = 0;
		cool = 0;
		off = 1;
		
		strcpy(status, "OFF ");
	}
	

	else if(input_switch != 6 && input_switch != 5)// && input_switch != 9 && input_switch != 10)
	{
		pgmnum = 2;
	}
	
	*/
	
// pgmnum mode switch check (1 = set, 2 = on)	
	
//	if(/* set pgmnum input */)
//	{
//		programmode = 1;
//	}
	
//	else if(/* pgmnum on input */)
//	{
//		programmode = 2;
//	}
	
//	switch_run();
	
	return;
}
		
/*		
void switch_run(void)
{

	if(heat == 1)
	{
		//turn on heat output
		//turn off cool output
	}
	
	else if(cool == 1)
	{
		//turn on cool output
		//turn off heat output
	}
	
	if(programmode = 2)
	{
		gettemp();
	}
	
	else if(programmode = 1)
	{
		program_menu();
	}
	
	if(fan == 1)
	{
		//turn on fan output
	}
}*/